// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Flexprops.pas' rev: 10.00

#ifndef FlexpropsHPP
#define FlexpropsHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Typinfo.hpp>	// Pascal unit
#include <Jpeg.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <Flexutils.hpp>	// Pascal unit
#include <Flexalpha.hpp>	// Pascal unit
#include <Flexhistory.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Flexprops
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TPropType { ptSimple, ptComplex, ptStrList, ptHexData };
#pragma option pop

#pragma option push -b-
enum TPropStyleItem { psReadOnly, psVisible, psDontStore, psNonVisual, psDisplayEdit, psEditForm, psScalable, psRef };
#pragma option pop

typedef Set<TPropStyleItem, psReadOnly, psRef>  TPropStyle;

typedef TMetaClass* TEditFormClass;

typedef TMetaClass* TCustomPropClass;

class DELPHICLASS TCustomProp;
typedef void __fastcall (__closure *TPropChangedEvent)(System::TObject* Sender, TCustomProp* Prop);

typedef void __fastcall (__closure *TPropStoredEvent)(System::TObject* Sender, TCustomProp* Prop, bool &IsStored, const AnsiString PropName = "");

typedef void __fastcall (__closure *TPropReadOnlyEvent)(System::TObject* Sender, TCustomProp* Prop, bool &IsReadOnly);

typedef void __fastcall (__closure *TPropHistoryActionEvent)(System::TObject* Sender, TCustomProp* Prop, TMetaClass* &ActionClass);

typedef void __fastcall (*TPictureLinkResolve)(System::TObject* Sender, const AnsiString LinkName, Graphics::TPicture* APicture);

typedef void __fastcall (*TBitmapLinkResolve)(System::TObject* Sender, const AnsiString LinkName, Graphics::TBitmap* ABitmap);

class DELPHICLASS TPropList;
class DELPHICLASS TPropRefList;
struct TPropRefItem;
typedef TPropRefItem *PPropRefItem;

class PASCALIMPLEMENTATION TPropRefList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* FList;
	Flexutils::TIdPool* FIdExist;
	Classes::TList* FIdRecode;
	int __fastcall GetCount(void);
	PPropRefItem __fastcall GetPropRefItem(int Index);
	int __fastcall IndexOfRecode(int OldID);
	
public:
	__fastcall TPropRefList(void);
	__fastcall virtual ~TPropRefList(void);
	int __fastcall AddRef(TCustomProp* AProp, const System::ShortString &APropName, System::PVariant AData);
	bool __fastcall AddIDAlias(int OldID, int NewID);
	int __fastcall GetIDAlias(int OldID);
	void __fastcall DeleteRef(int Index);
	void __fastcall ResolveRef(int Index);
	void __fastcall ResolveAllRefs(void);
	void __fastcall Clear(void);
	__property int Count = {read=GetCount, nodefault};
	__property PPropRefItem Refs[int Index] = {read=GetPropRefItem};
};


#pragma option push -b-
enum TPropListDataMode { plmNone, plmLoading, plmSaving };
#pragma option pop

class PASCALIMPLEMENTATION TPropList : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TCustomProp* operator[](AnsiString Name) { return Props[Name]; }
	
private:
	System::TObject* FOwner;
	TPropRefList* FRefList;
	Classes::TStringList* FPropList;
	Flexutils::TNotifyLink* FNotifyLink;
	Flexhistory::THistory* FHistory;
	bool FHistoryIgnoreReadOnly;
	Flexhistory::THistoryState FHistoryStateForList;
	bool FPropValueLoading;
	TPropChangedEvent FOnPropChanged;
	TPropChangedEvent FOnPropBeforeChanged;
	TPropStoredEvent FOnPropStored;
	TPropReadOnlyEvent FOnPropReadOnly;
	TPropHistoryActionEvent FOnPropHistoryAction;
	TCustomProp* __fastcall GetPropByIndex(int Index);
	int __fastcall GetPropsCount(void);
	TCustomProp* __fastcall GetPropByName(const AnsiString Name);
	AnsiString __fastcall GetPropName(int Index);
	int __fastcall GetVisibleCount(void);
	TCustomProp* __fastcall GetVisibleProp(int Index);
	AnsiString __fastcall GetVisiblePropName(int Index);
	bool __fastcall GetResolving(void);
	Flexutils::TNotifyLink* __fastcall GetNotifyLink(void);
	
protected:
	int FResolveCount;
	TPropListDataMode FDataMode;
	int FDataModeCount;
	void __fastcall DoBeforeChanged(TCustomProp* Prop);
	void __fastcall DoChanged(TCustomProp* Prop);
	bool __fastcall DoPropIsStored(TCustomProp* Prop, const AnsiString PropName = "");
	bool __fastcall IsNameValid(const AnsiString AName);
	TCustomProp* __fastcall GetComplexPropInstance(TCustomProp* Prop, const AnsiString PropName);
	void __fastcall SavePropValue(Flexutils::TFlexFiler* Filer, const AnsiString Indent, TCustomProp* Prop, const AnsiString PropName, bool IsComplex);
	void __fastcall SaveComplexProp(Flexutils::TFlexFiler* Filer, TCustomProp* Prop, const AnsiString PropName, const AnsiString Indent, bool ForceSave = false);
	TCustomProp* __fastcall LoadPropValue(Flexutils::TFlexFiler* Filer, TCustomProp* ComplexProp, const AnsiString First);
	bool __fastcall LoadComplexProp(Flexutils::TFlexFiler* Filer, const AnsiString First, TCustomProp* Prop);
	__property bool PropValueLoading = {read=FPropValueLoading, nodefault};
	
public:
	__fastcall TPropList(System::TObject* AOwner);
	__fastcall virtual ~TPropList(void);
	bool __fastcall Assign(TPropList* PropList);
	void __fastcall BeginResolve(TPropRefList* ARefList);
	void __fastcall EndResolve(void);
	void __fastcall Clear(void);
	void __fastcall BeginLoading(void);
	void __fastcall BeginSaving(void);
	void __fastcall EndLoadSave(void);
	int __fastcall Add(TCustomProp* Prop, const AnsiString AName);
	bool __fastcall AddLoadedIDAlias(int LoadedID, int NewID);
	int __fastcall IndexOf(TCustomProp* Prop);
	bool __fastcall IsReadOnly(TCustomProp* Prop);
	int __fastcall VisibleIndexOf(TCustomProp* Prop);
	int __fastcall GetRealIndex(int VisibleIndex);
	int __fastcall GetVisibleIndex(int RealIndex);
	void __fastcall Delete(int Index);
	bool __fastcall SaveProperty(Flexutils::TFlexFiler* Filer, TCustomProp* Prop, const AnsiString Indent, AnsiString PropName = "", bool ForceSave = false);
	TCustomProp* __fastcall LoadProperty(Flexutils::TFlexFiler* Filer, const AnsiString First, bool WithoutBeginLoading = false);
	bool __fastcall SaveToFiler(Flexutils::TFlexFiler* Filer, const AnsiString Indent, bool ForceSave = false);
	void __fastcall LoadFromFiler(Flexutils::TFlexFiler* Filer, const AnsiString First, TPropRefList* RefList);
	__property System::TObject* Owner = {read=FOwner};
	__property TPropListDataMode DataMode = {read=FDataMode, nodefault};
	__property int Count = {read=GetPropsCount, nodefault};
	__property TCustomProp* Props[AnsiString Name] = {read=GetPropByName/*, default*/};
	__property AnsiString PropNames[int Index] = {read=GetPropName};
	__property TCustomProp* ByIndex[int Index] = {read=GetPropByIndex};
	__property int VisibleCount = {read=GetVisibleCount, nodefault};
	__property TCustomProp* VisibleProps[int Index] = {read=GetVisibleProp};
	__property AnsiString VisiblePropNames[int Index] = {read=GetVisiblePropName};
	__property bool Resolving = {read=GetResolving, nodefault};
	__property TPropRefList* RefList = {read=FRefList, write=FRefList};
	__property Flexutils::TNotifyLink* NotifyLink = {read=GetNotifyLink, write=FNotifyLink};
	__property Flexhistory::THistory* History = {read=FHistory, write=FHistory};
	__property bool HistoryIgnoreReadOnly = {read=FHistoryIgnoreReadOnly, write=FHistoryIgnoreReadOnly, nodefault};
	__property Flexhistory::THistoryState HistoryStateForList = {read=FHistoryStateForList, write=FHistoryStateForList, nodefault};
	__property TPropChangedEvent OnPropChanged = {read=FOnPropChanged, write=FOnPropChanged};
	__property TPropChangedEvent OnPropBeforeChanged = {read=FOnPropBeforeChanged, write=FOnPropBeforeChanged};
	__property TPropStoredEvent OnPropStored = {read=FOnPropStored, write=FOnPropStored};
	__property TPropReadOnlyEvent OnPropReadOnly = {read=FOnPropReadOnly, write=FOnPropReadOnly};
	__property TPropHistoryActionEvent OnPropHistoryAction = {read=FOnPropHistoryAction, write=FOnPropHistoryAction};
};


class PASCALIMPLEMENTATION TCustomProp : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TPropList* FOwner;
	TCustomProp* FParent;
	TPropStyle FStyle;
	TMetaClass* FEditFormClass;
	AnsiString __fastcall GetName();
	void __fastcall SetStyle(const TPropStyle Value);
	Flexutils::TNotifyLink* __fastcall GetNotifyLink(void);
	
protected:
	TPropType FPropType;
	bool FIsEnum;
	Flexutils::TNotifyLink* FNotifyLink;
	bool FSkipHistoryAction;
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetDisplayValue(const AnsiString Value);
	virtual void __fastcall DoBeforeChanged(void);
	virtual void __fastcall DoChanged(void);
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	virtual TPropType __fastcall GetPropType(const AnsiString PropName);
	
public:
	__fastcall TCustomProp(TPropList* AOwner, const AnsiString AName);
	__fastcall virtual ~TCustomProp(void);
	bool __fastcall Assign(TCustomProp* Prop);
	virtual void __fastcall Setup(Graphics::TCanvas* Canvas, int Scale = 0x64);
	virtual bool __fastcall Edit(void);
	virtual void __fastcall GetEnumList(Classes::TStrings* List);
	virtual bool __fastcall IsComplexStored(const AnsiString PropName);
	void __fastcall InitPublished(TPropList* AOwner, TCustomProp* PublishedProp);
	TCustomProp* __fastcall GetPublishedComplexProp(const AnsiString PropName);
	void __fastcall GetPropNames(Classes::TStrings* StrList);
	bool __fastcall IsParentOf(TCustomProp* Prop);
	__property TPropList* Owner = {read=FOwner, write=FOwner};
	__property AnsiString Name = {read=GetName};
	__property TCustomProp* Parent = {read=FParent};
	__property TPropStyle Style = {read=FStyle, write=SetStyle, nodefault};
	__property TPropType PropType = {read=FPropType, nodefault};
	__property AnsiString DisplayValue = {read=GetDisplayValue, write=SetDisplayValue};
	__property bool IsEnum = {read=FIsEnum, nodefault};
	__property TMetaClass* EditFormClass = {read=FEditFormClass, write=FEditFormClass};
	__property Flexutils::TNotifyLink* NotifyLink = {read=GetNotifyLink, write=FNotifyLink};
	__property Variant PropData[AnsiString PropName] = {read=GetPropValue, write=SetPropValue};
	__property TPropType PublishedPropType[AnsiString PropName] = {read=GetPropType};
};


class DELPHICLASS TIdHistoryAction;
class PASCALIMPLEMENTATION TIdHistoryAction : public Flexhistory::THistoryStreamAction 
{
	typedef Flexhistory::THistoryStreamAction inherited;
	
protected:
	unsigned FSourceId;
	AnsiString FSourcePropName;
	virtual void __fastcall DoBeginAction(System::TObject* Source);
	
public:
	__property unsigned SourceId = {read=FSourceId, write=FSourceId, nodefault};
	__property AnsiString SourcePropName = {read=FSourcePropName, write=FSourcePropName};
public:
	#pragma option push -w-inl
	/* THistoryStreamAction.Destroy */ inline __fastcall virtual ~TIdHistoryAction(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* THistoryAction.Create */ inline __fastcall virtual TIdHistoryAction(Flexhistory::THistory* AOwner, Flexhistory::THistoryGroup* AParent) : Flexhistory::THistoryStreamAction(AOwner, AParent) { }
	#pragma option pop
	
};


class DELPHICLASS TPropHistoryAction;
class PASCALIMPLEMENTATION TPropHistoryAction : public TIdHistoryAction 
{
	typedef TIdHistoryAction inherited;
	
protected:
	virtual bool __fastcall ProcessSource(Classes::TStream* Stream, System::TObject* Source, bool DoLoad);
public:
	#pragma option push -w-inl
	/* THistoryStreamAction.Destroy */ inline __fastcall virtual ~TPropHistoryAction(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* THistoryAction.Create */ inline __fastcall virtual TPropHistoryAction(Flexhistory::THistory* AOwner, Flexhistory::THistoryGroup* AParent) : TIdHistoryAction(AOwner, AParent) { }
	#pragma option pop
	
};


class DELPHICLASS TPropHistoryGroup;
class PASCALIMPLEMENTATION TPropHistoryGroup : public Flexhistory::THistoryGroup 
{
	typedef Flexhistory::THistoryGroup inherited;
	
public:
	__fastcall virtual TPropHistoryGroup(Flexhistory::THistory* AOwner, Flexhistory::THistoryGroup* AParent);
public:
	#pragma option push -w-inl
	/* THistoryGroup.Destroy */ inline __fastcall virtual ~TPropHistoryGroup(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEnumProp;
class PASCALIMPLEMENTATION TEnumProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	int FEnumIndex;
	Classes::TStrings* FEnumList;
	int __fastcall GetEnumCount(void);
	
protected:
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetEnumIndex(int Value);
	__property Classes::TStrings* EnumList = {read=FEnumList, write=FEnumList};
	
public:
	__fastcall TEnumProp(TPropList* AOwner, const AnsiString AName);
	__fastcall virtual ~TEnumProp(void);
	int __fastcall AddItem(const AnsiString s);
	void __fastcall SetItem(int EnumIndex, const AnsiString s);
	bool __fastcall SetEnumType(Typinfo::PTypeInfo TypeInfo);
	virtual void __fastcall GetEnumList(Classes::TStrings* List);
	__property int EnumIndex = {read=FEnumIndex, write=SetEnumIndex, nodefault};
	__property int EnumCount = {read=GetEnumCount, nodefault};
};


class DELPHICLASS TBoolProp;
class PASCALIMPLEMENTATION TBoolProp : public TEnumProp 
{
	typedef TEnumProp inherited;
	
private:
	void __fastcall SetValue(bool Value);
	bool __fastcall GetValue(void);
	
protected:
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	
public:
	__fastcall TBoolProp(TPropList* AOwner, const AnsiString AName);
	__property bool Value = {read=GetValue, write=SetValue, nodefault};
public:
	#pragma option push -w-inl
	/* TEnumProp.Destroy */ inline __fastcall virtual ~TBoolProp(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TGetIntEvent)(System::TObject* Sender, /* out */ int &Value);

class DELPHICLASS TIntProp;
class PASCALIMPLEMENTATION TIntProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	int FValue;
	int *FSource;
	TGetIntEvent FOnGetValue;
	void __fastcall SetValue(int Value);
	int __fastcall GetValue(void);
	
protected:
	int FBeforeValue;
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetDisplayValue(const AnsiString Value);
	
public:
	__fastcall TIntProp(TPropList* AOwner, const AnsiString AName);
	__property int Value = {read=GetValue, write=SetValue, nodefault};
	__property int BeforeValue = {read=FBeforeValue, write=FBeforeValue, nodefault};
	__property int SavedValue = {read=FValue, nodefault};
	__property System::PInteger Source = {read=FSource, write=FSource};
	__property TGetIntEvent OnGetValue = {read=FOnGetValue, write=FOnGetValue};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TIntProp(void) { }
	#pragma option pop
	
};


class DELPHICLASS TLongWordProp;
class PASCALIMPLEMENTATION TLongWordProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
protected:
	unsigned FValue;
	virtual void __fastcall SetValue(unsigned Value);
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetDisplayValue(const AnsiString Value);
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	
public:
	__fastcall TLongWordProp(TPropList* AOwner, const AnsiString AName);
	__property unsigned Value = {read=FValue, write=SetValue, nodefault};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TLongWordProp(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDoubleProp;
class PASCALIMPLEMENTATION TDoubleProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	double FValue;
	void __fastcall SetValue(double Value);
	
protected:
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetDisplayValue(const AnsiString Value);
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	
public:
	__fastcall TDoubleProp(TPropList* AOwner, const AnsiString AName);
	__property double Value = {read=FValue, write=SetValue};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TDoubleProp(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDateTimeProp;
class PASCALIMPLEMENTATION TDateTimeProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	System::TDateTime FValue;
	void __fastcall SetValue(System::TDateTime Value);
	
protected:
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetDisplayValue(const AnsiString Value);
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	
public:
	__fastcall TDateTimeProp(TPropList* AOwner, const AnsiString AName);
	__property System::TDateTime Value = {read=FValue, write=SetValue};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TDateTimeProp(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TGetStringEvent)(System::TObject* Sender, /* out */ AnsiString &s);

class DELPHICLASS TStrProp;
class PASCALIMPLEMENTATION TStrProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
protected:
	AnsiString FValue;
	TGetStringEvent FOnGetString;
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetValue(const AnsiString Value);
	virtual AnsiString __fastcall GetValue();
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	
public:
	__fastcall TStrProp(TPropList* AOwner, const AnsiString AName);
	__property AnsiString Value = {read=GetValue, write=SetValue};
	__property AnsiString SavedValue = {read=FValue, write=FValue};
	__property TGetStringEvent OnGetString = {read=FOnGetString, write=FOnGetString};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TStrProp(void) { }
	#pragma option pop
	
};


class DELPHICLASS TStrListProp;
class PASCALIMPLEMENTATION TStrListProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
public:
	AnsiString operator[](int Index) { return Lines[Index]; }
	
private:
	Classes::TStringList* FStrList;
	void __fastcall SetText(const AnsiString Value);
	AnsiString __fastcall GetLine(int Index);
	int __fastcall GetLinesCount(void);
	AnsiString __fastcall GetText();
	void __fastcall SetLine(int Index, const AnsiString Value);
	HIDESBASE AnsiString __fastcall GetName(int Index);
	AnsiString __fastcall GetValue(const AnsiString Name);
	AnsiString __fastcall GetValueByIndex(int Index);
	void __fastcall SetValue(const AnsiString Name, const AnsiString Value);
	void __fastcall SetValueByIndex(int Index, const AnsiString Value);
	void __fastcall SetName(int Index, const AnsiString Value);
	
protected:
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	
public:
	__fastcall TStrListProp(TPropList* AOwner, const AnsiString AName);
	__fastcall virtual ~TStrListProp(void);
	HIDESBASE void __fastcall Assign(Classes::TStrings* Source);
	void __fastcall AssignTo(Classes::TStrings* Dest);
	void __fastcall Clear(void);
	int __fastcall Add(const AnsiString s);
	bool __fastcall Insert(int Index, const AnsiString S);
	void __fastcall Delete(int Index);
	void __fastcall RemoveByName(const AnsiString Name);
	int __fastcall IndexOf(const AnsiString s);
	int __fastcall IndexOfName(const AnsiString s);
	__property int LinesCount = {read=GetLinesCount, nodefault};
	__property AnsiString Lines[int Index] = {read=GetLine, write=SetLine/*, default*/};
	__property AnsiString Names[int Index] = {read=GetName, write=SetName};
	__property AnsiString Values[AnsiString Name] = {read=GetValue, write=SetValue};
	__property AnsiString ValuesByIndex[int Index] = {read=GetValueByIndex, write=SetValueByIndex};
	__property AnsiString Text = {read=GetText, write=SetText};
};


class DELPHICLASS TUserDataProp;
class PASCALIMPLEMENTATION TUserDataProp : public TStrListProp 
{
	typedef TStrListProp inherited;
	
public:
	#pragma option push -w-inl
	/* TStrListProp.Create */ inline __fastcall TUserDataProp(TPropList* AOwner, const AnsiString AName) : TStrListProp(AOwner, AName) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TStrListProp.Destroy */ inline __fastcall virtual ~TUserDataProp(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TPropDataEvent)(System::TObject* Sender, Variant &Value);

class DELPHICLASS TDataProp;
class PASCALIMPLEMENTATION TDataProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	TPropDataEvent FOnGetPropData;
	TPropDataEvent FOnSetPropData;
	
protected:
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	
public:
	__fastcall TDataProp(TPropList* AOwner, const AnsiString AName);
	__property TPropDataEvent OnGetPropData = {read=FOnGetPropData, write=FOnGetPropData};
	__property TPropDataEvent OnSetPropData = {read=FOnSetPropData, write=FOnSetPropData};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TDataProp(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TBrushMethod { bmHatch, bmGradient, bmBitmap };
#pragma option pop

class DELPHICLASS TBrushProp;
class PASCALIMPLEMENTATION TBrushProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	Graphics::TBrush* FBrush;
	TBrushMethod FMethod;
	Flexutils::TGradientStyle FGradStyle;
	Graphics::TColor FGradBeginColor;
	Graphics::TColor FGradEndColor;
	Graphics::TBitmap* FBitmap;
	Flexutils::TTiledBitmapCache FCache;
	AnsiString FBitmapLinkName;
	bool FBitmapMasked;
	Graphics::TColor FBitmapMaskColor;
	bool FBitmapCache;
	Flexutils::TBitmapDisplay FBitmapDisplay;
	Graphics::TColor __fastcall GetColor(void);
	Graphics::TBrushStyle __fastcall GetStyle(void);
	void __fastcall SetColor(const Graphics::TColor Value);
	HIDESBASE void __fastcall SetStyle(const Graphics::TBrushStyle Value);
	void __fastcall SetGradBeginColor(const Graphics::TColor Value);
	void __fastcall SetGradEndColor(const Graphics::TColor Value);
	void __fastcall SetGradStyle(const Flexutils::TGradientStyle Value);
	bool __fastcall GetIsPaintAlternate(void);
	void __fastcall SetBitmap(const Graphics::TBitmap* Value);
	void __fastcall SetBitmapMaskColor(const Graphics::TColor Value);
	void __fastcall SetBitmapMasked(const bool Value);
	void __fastcall SetBitmapCache(const bool Value);
	void __fastcall SetBitmapDisplay(const Flexutils::TBitmapDisplay Value);
	void __fastcall SetBitmapLinkName(const AnsiString Value);
	void __fastcall SetMethod(const TBrushMethod Value);
	bool __fastcall GetIsClear(void);
	bool __fastcall StoreBitmap(void);
	bool __fastcall StoreBitmapLinkName(void);
	
protected:
	virtual TPropType __fastcall GetPropType(const AnsiString PropName);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual AnsiString __fastcall GetDisplayValue();
	virtual void __fastcall BitmapChange(System::TObject* Sender);
	void __fastcall ResetCache(void);
	
public:
	__fastcall TBrushProp(TPropList* AOwner, const AnsiString AName);
	__fastcall virtual ~TBrushProp(void);
	void __fastcall InitBitmap(int Width = 0x0, int Height = 0x0);
	void __fastcall FreeBitmap(void);
	bool __fastcall UpdateBitmapLink(void);
	virtual void __fastcall Setup(Graphics::TCanvas* Canvas, int Scale = 0x64);
	virtual void __fastcall Translate(const Flexutils::TTranslateInfo &TranslateInfo);
	void __fastcall PaintAlternate(Graphics::TCanvas* Canvas, Types::TRect &PaintRect, const Types::TRect &RefreshRect, int Scale = 0x64, bool ClipTransparent = false);
	__property bool IsPaintAlternate = {read=GetIsPaintAlternate, nodefault};
	__property bool IsClear = {read=GetIsClear, nodefault};
	
__published:
	__property TBrushMethod Method = {read=FMethod, write=SetMethod, default=0};
	__property Graphics::TColor Color = {read=GetColor, write=SetColor, default=536870911};
	__property Graphics::TBrushStyle Style = {read=GetStyle, write=SetStyle, default=0};
	__property Graphics::TBitmap* Bitmap = {read=FBitmap, write=SetBitmap, stored=StoreBitmap};
	__property AnsiString BitmapLinkName = {read=FBitmapLinkName, write=SetBitmapLinkName, stored=StoreBitmapLinkName};
	__property bool BitmapMasked = {read=FBitmapMasked, write=SetBitmapMasked, default=0};
	__property Graphics::TColor BitmapMaskColor = {read=FBitmapMaskColor, write=SetBitmapMaskColor, default=0};
	__property bool BitmapCache = {read=FBitmapCache, write=SetBitmapCache, default=0};
	__property Flexutils::TBitmapDisplay BitmapDisplay = {read=FBitmapDisplay, write=SetBitmapDisplay, default=1};
	__property Flexutils::TGradientStyle GradStyle = {read=FGradStyle, write=SetGradStyle, default=0};
	__property Graphics::TColor GradBeginColor = {read=FGradBeginColor, write=SetGradBeginColor, default=0};
	__property Graphics::TColor GradEndColor = {read=FGradEndColor, write=SetGradEndColor, default=0};
};


class DELPHICLASS TLineCapProp;
class PASCALIMPLEMENTATION TLineCapProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	int FCapStyle;
	bool FFixedSize;
	int FSize;
	bool FFixedOutlineColor;
	Graphics::TColor FOutlineColor;
	bool FFixedFillColor;
	Graphics::TColor FFillColor;
	void __fastcall SetCapStyle(const int Value);
	void __fastcall SetFillColor(const Graphics::TColor Value);
	void __fastcall SetFixedFillColor(const bool Value);
	void __fastcall SetFixedOutlineColor(const bool Value);
	void __fastcall SetFixedSize(const bool Value);
	void __fastcall SetOutlineColor(const Graphics::TColor Value);
	void __fastcall SetSize(const int Value);
	
protected:
	virtual AnsiString __fastcall GetDisplayValue();
	
public:
	__fastcall TLineCapProp(TPropList* AOwner, const AnsiString AName);
	__fastcall virtual ~TLineCapProp(void);
	int __fastcall GetActiveSize(int PenWidth, int PixelSize = 0x3e8);
	
__published:
	__property int CapStyle = {read=FCapStyle, write=SetCapStyle, default=0};
	__property bool FixedSize = {read=FFixedSize, write=SetFixedSize, default=0};
	__property int Size = {read=FSize, write=SetSize, default=8000};
	__property bool FixedOutlineColor = {read=FFixedOutlineColor, write=SetFixedOutlineColor, default=0};
	__property Graphics::TColor OutlineColor = {read=FOutlineColor, write=SetOutlineColor, default=0};
	__property bool FixedFillColor = {read=FFixedFillColor, write=SetFixedFillColor, default=0};
	__property Graphics::TColor FillColor = {read=FFillColor, write=SetFillColor, default=16777215};
};


#pragma option push -b-
enum TPenEndCap { pecFlat, pecSquare, pecRound };
#pragma option pop

#pragma option push -b-
enum TPenJoin { pjBevel, pjMiter, pjRound };
#pragma option pop

class DELPHICLASS TPenProp;
class PASCALIMPLEMENTATION TPenProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	int __fastcall GetActiveWidth(void);
	void __fastcall SetColor(const Graphics::TColor Value);
	HIDESBASE void __fastcall SetStyle(const Graphics::TPenStyle Value);
	void __fastcall SetWidth(const int Value);
	void __fastcall SetMode(const Graphics::TPenMode Value);
	void __fastcall SetEndCap(const TPenEndCap Value);
	void __fastcall SetJoin(const TPenJoin Value);
	void __fastcall SetSolidAsInside(const bool Value);
	
protected:
	Graphics::TPenStyle FStyle;
	Graphics::TColor FColor;
	Graphics::TPenMode FMode;
	int FWidth;
	TPenEndCap FEndCap;
	TPenJoin FJoin;
	bool FSolidAsInside;
	virtual AnsiString __fastcall GetDisplayValue();
	
public:
	__fastcall TPenProp(TPropList* AOwner, const AnsiString AName);
	virtual void __fastcall Setup(Graphics::TCanvas* Canvas, int Scale = 0x64);
	void __fastcall GetPaintData(int &AWidth, Graphics::TPenStyle &AStyle, bool &IsGeometricPen, int Scale = 0x64);
	__property int ActiveWidth = {read=GetActiveWidth, nodefault};
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=0};
	__property Graphics::TPenStyle Style = {read=FStyle, write=SetStyle, default=0};
	__property Graphics::TPenMode Mode = {read=FMode, write=SetMode, default=4};
	__property int Width = {read=FWidth, write=SetWidth, default=1000};
	__property TPenEndCap EndCap = {read=FEndCap, write=SetEndCap, default=2};
	__property TPenJoin Join = {read=FJoin, write=SetJoin, default=2};
	__property bool SolidAsInside = {read=FSolidAsInside, write=SetSolidAsInside, default=1};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TPenProp(void) { }
	#pragma option pop
	
};


class DELPHICLASS TFontProp;
class PASCALIMPLEMENTATION TFontProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	Graphics::TFont* FFont;
	int FFontHeight;
	Graphics::TFontCharset __fastcall GetCharset(void);
	HFONT __fastcall GetHandle(void);
	int __fastcall GetSize(void);
	HIDESBASE AnsiString __fastcall GetName();
	Graphics::TFontPitch __fastcall GetPitch(void);
	Graphics::TFontStyles __fastcall GetStyle(void);
	Graphics::TColor __fastcall GetColor(void);
	int __fastcall GetPixelsPerInch(void);
	void __fastcall SetCharset(const Graphics::TFontCharset Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetHandle(const HFONT Value);
	void __fastcall SetHeight(const int Value);
	void __fastcall SetName(const AnsiString Value);
	void __fastcall SetPitch(const Graphics::TFontPitch Value);
	void __fastcall SetSize(const int Value);
	HIDESBASE void __fastcall SetStyle(const Graphics::TFontStyles Value);
	void __fastcall SetPixelsPerInch(const int Value);
	
protected:
	virtual AnsiString __fastcall GetDisplayValue();
	
public:
	__fastcall TFontProp(TPropList* AOwner, const AnsiString AName);
	__fastcall virtual ~TFontProp(void);
	virtual void __fastcall Setup(Graphics::TCanvas* Canvas, int Scale = 0x64);
	virtual bool __fastcall Edit(void);
	void __fastcall GetFont(Graphics::TFont* &AFont);
	void __fastcall SetFont(const Graphics::TFont* AFont);
	__property HFONT Handle = {read=GetHandle, write=SetHandle, nodefault};
	
__published:
	__property int PixelsPerInch = {read=GetPixelsPerInch, write=SetPixelsPerInch, stored=false, nodefault};
	__property Graphics::TFontCharset Charset = {read=GetCharset, write=SetCharset, default=1};
	__property Graphics::TColor Color = {read=GetColor, write=SetColor, default=0};
	__property int Height = {read=FFontHeight, write=SetHeight, stored=false, nodefault};
	__property AnsiString Name = {read=GetName, write=SetName};
	__property Graphics::TFontPitch Pitch = {read=GetPitch, write=SetPitch, default=0};
	__property int Size = {read=GetSize, write=SetSize, nodefault};
	__property Graphics::TFontStyles Style = {read=GetStyle, write=SetStyle, default=0};
};


typedef void __fastcall (__closure *TPicturePaintBufferEvent)(System::TObject* Sender, Flexalpha::TAlphaBuffer* Buffer, Graphics::TCanvas* Canvas, Graphics::TGraphic* Graphic, bool &DrawDefault);

class DELPHICLASS TPictureProp;
class PASCALIMPLEMENTATION TPictureProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	Graphics::TPicture* FPicture;
	TMetaClass* FGraphicClass;
	bool FEmpty;
	int FWidth;
	int FHeight;
	int FColumns;
	int FRows;
	bool FMasked;
	Graphics::TColor FMaskColor;
	bool FBuffered;
	Classes::TMemoryStream* FPictureBuffer;
	AnsiString FLinkName;
	bool FUsePaintBuffer;
	bool FDrawing;
	TPicturePaintBufferEvent FOnPaintFastBuffer;
	bool __fastcall GetIsLoaded(void);
	Types::TRect __fastcall GetImgRect(int Index);
	Types::TRect __fastcall GetCellSizeRect();
	Graphics::TGraphic* __fastcall GetGraphic(void);
	void __fastcall PictureChange(System::TObject* Sender);
	void __fastcall SetGraphic(const Graphics::TGraphic* Value);
	void __fastcall SetColumns(const int Value);
	void __fastcall SetRows(const int Value);
	void __fastcall SetMaskColor(const Graphics::TColor Value);
	void __fastcall SetMasked(const bool Value);
	void __fastcall SetBuffered(const bool Value);
	void __fastcall SetFastBuffer(const bool Value);
	void __fastcall SetLinkName(const AnsiString Value);
	bool __fastcall StoreGraphic(void);
	bool __fastcall StoreLinkName(void);
	
protected:
	Flexalpha::TAlphaBuffer* FPaintBuffer;
	virtual void __fastcall SetPropValue(const AnsiString PropName, const Variant &Value);
	virtual Variant __fastcall GetPropValue(const AnsiString PropName);
	virtual TPropType __fastcall GetPropType(const AnsiString PropName);
	virtual AnsiString __fastcall GetDisplayValue();
	virtual bool __fastcall GetIsRaster(void);
	virtual Graphics::TBitmap* __fastcall GetFrameBitmap(Graphics::TGraphic* Graphic, int FrameIndex);
	void __fastcall RefreshPaintBuffer(void);
	virtual void __fastcall PaintBufferStore(System::TObject* Sender, Graphics::TCanvas* Canvas, Graphics::TGraphic* Graphic);
	
public:
	__fastcall TPictureProp(TPropList* AOwner, const AnsiString AName);
	__fastcall virtual ~TPictureProp(void);
	void __fastcall Draw(Graphics::TCanvas* Canvas, Types::TRect &R, int FrameIndex, bool ClipTransparent = false, Flexalpha::TAlphaBuffer* DestBuffer = (Flexalpha::TAlphaBuffer*)(0x0));
	void __fastcall Clear(bool RemoveLink = false);
	bool __fastcall UpdateImageLink(void);
	Graphics::TPicture* __fastcall CreatePictureFromBuffer(void);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
	void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall LoadFromFile(const AnsiString FileName);
	void __fastcall SaveToFile(const AnsiString FileName);
	__property bool Buffered = {read=FBuffered, write=SetBuffered, nodefault};
	__property TMetaClass* GraphicClass = {read=FGraphicClass};
	__property int Width = {read=FWidth, nodefault};
	__property int Height = {read=FHeight, nodefault};
	__property bool IsLoaded = {read=GetIsLoaded, nodefault};
	__property bool IsRaster = {read=GetIsRaster, nodefault};
	__property Types::TRect ImgRect[int Index] = {read=GetImgRect};
	__property Types::TRect CellSizeRect = {read=GetCellSizeRect};
	__property TPicturePaintBufferEvent OnPaintFastBuffer = {read=FOnPaintFastBuffer, write=FOnPaintFastBuffer};
	
__published:
	__property Graphics::TGraphic* Graphic = {read=GetGraphic, write=SetGraphic, stored=StoreGraphic};
	__property int Columns = {read=FColumns, write=SetColumns, default=1};
	__property int Rows = {read=FRows, write=SetRows, default=1};
	__property bool Masked = {read=FMasked, write=SetMasked, default=0};
	__property Graphics::TColor MaskColor = {read=FMaskColor, write=SetMaskColor, default=0};
	__property AnsiString LinkName = {read=FLinkName, write=SetLinkName, stored=StoreLinkName};
	__property bool FastBuffer = {read=FUsePaintBuffer, write=SetFastBuffer, default=0};
};


#pragma option push -b-
enum TBackgroundPictureOption { bpOffsetLeft, bpOffsetTop, bpNewWidth, bpNewHeight, bpStretchHoriz, bpStretchVert, bpScaledSize, bpCenterHoriz, bpCenterVert, bpAlignRight, bpAlignBottom };
#pragma option pop

typedef Set<TBackgroundPictureOption, bpOffsetLeft, bpAlignBottom>  TBackgroundPictureOptions;

class DELPHICLASS TBackgroundOptionsProp;
class PASCALIMPLEMENTATION TBackgroundOptionsProp : public TCustomProp 
{
	typedef TCustomProp inherited;
	
private:
	bool FBrushEnabled;
	bool FPictureEnabled;
	TBackgroundPictureOptions FPictureOptions;
	int FTop;
	int FLeft;
	int FWidth;
	int FHeight;
	bool __fastcall GetCenter(void);
	bool __fastcall GetStretch(void);
	void __fastcall SetBrushEnabled(const bool Value);
	void __fastcall SetPictureEnabled(const bool Value);
	void __fastcall SetPictureOptions(const TBackgroundPictureOptions Value);
	void __fastcall SetTop(int Value);
	void __fastcall SetLeft(int Value);
	void __fastcall SetWidth(int Value);
	void __fastcall SetHeight(int Value);
	void __fastcall SetStretch(bool Value);
	void __fastcall SetCenter(bool Value);
	
protected:
	virtual AnsiString __fastcall GetDisplayValue();
	
public:
	__fastcall TBackgroundOptionsProp(TPropList* AOwner, const AnsiString AName);
	Types::TRect __fastcall GetPicturePaintRect(TPictureProp* Picture, const Types::TRect &BackgroundRect, int Scale);
	void __fastcall Draw(Graphics::TCanvas* Canvas, Types::TRect &R, TPictureProp* Picture, TBrushProp* Brush, int Scale, const Types::TRect &PanelRefreshRect, bool ClipTransparent = false);
	__property bool Stretch = {read=GetStretch, write=SetStretch, default=1};
	__property bool Center = {read=GetCenter, write=SetCenter, default=0};
	
__published:
	__property bool PictureEnabled = {read=FPictureEnabled, write=SetPictureEnabled, default=1};
	__property bool BrushEnabled = {read=FBrushEnabled, write=SetBrushEnabled, default=1};
	__property TBackgroundPictureOptions PictureOptions = {read=FPictureOptions, write=SetPictureOptions, default=112};
	__property int Top = {read=FTop, write=SetTop, default=0};
	__property int Left = {read=FLeft, write=SetLeft, default=0};
	__property int Width = {read=FWidth, write=SetWidth, default=0};
	__property int Height = {read=FHeight, write=SetHeight, default=0};
public:
	#pragma option push -w-inl
	/* TCustomProp.Destroy */ inline __fastcall virtual ~TBackgroundOptionsProp(void) { }
	#pragma option pop
	
};


struct TPropRefItem
{
	
public:
	TCustomProp* Prop;
	System::ShortString PropName;
	Variant *Data;
} ;

typedef int __fastcall (__closure *TGetIDAlias)(int OldID);

//-- var, const, procedure ---------------------------------------------------
static const Word DefaultLineCapSize = 0x1f40;
static const Shortint psNoCap = 0x0;
static const Shortint psArrow0 = -1;
static const Shortint psDblArrow0 = -2;
static const Shortint psBackArrow0 = -3;
static const Shortint psBackDblArrow0 = -4;
static const Shortint psArrow1 = -5;
static const Shortint psDblArrow1 = -6;
static const Shortint psBackArrow1 = -7;
static const Shortint psBackDblArrow1 = -8;
static const Shortint psArrow = -9;
static const Shortint psTriangle = -10;
static const Shortint psDblTriangle = -11;
static const Shortint psBackTriangle = -12;
static const Shortint psBackDblTriangle = -13;
static const Shortint psSquare = -14;
static const Shortint psCircle = -15;
static const Shortint psDotCircle = -16;
static const Shortint psRhombus = -17;
static const Shortint psThinRect = -18;
static const Shortint psLastStandard = -18;
extern PACKAGE TPictureLinkResolve ResolvePictureLink;
extern PACKAGE TBitmapLinkResolve ResolveBitmapLink;
extern PACKAGE bool GeometricPenChecked;
extern PACKAGE bool GeometricPenEnabled;
extern PACKAGE void __fastcall RegisterDefaultPropEditForm(TMetaClass* PropClass, TMetaClass* EditFormClass);

}	/* namespace Flexprops */
using namespace Flexprops;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Flexprops
